;Functions by Gamemaster :)
Function init_ym()
Return CallDLL("RetroMusic.dll","init_ym")
End Function
Function stop_ym()
Return CallDLL("RetroMusic.dll","stop_ym")
End Function
Function free_ym()
Return CallDLL("RetroMusic.dll","free_ym")
End Function

Function play_ym(music$)
s$=" "+music$
iBankSize=Len(s$)+1
mBankIn = CreateBank(iBankSize)
PokeString(mBankIn,s$)
CallDLL("RetroMusic.dll","play_ym",mBankIn)
FreeBank mBankIn
End Function

; ###################################
; # String poking and peeking       #
; ###################################
; # Code: Rob Hutchinson            #
; ###################################
; # Date:        15/02/2002         #
; # Last Chance: 15/02/2002         #
; ###################################
; Null terminated string poke.
Function PokeString(mBankAddr,sStringOut$,iBufferOffset = 0)
	For n = 1 To Len(sStringOut$)
		PokeByte mBankAddr,iBufferOffset,Asc(Mid$(sStringOut$,n,1))
		iBufferOffset = iBufferOffset + 1
	Next
	PokeByte mBankAddr,iBufferOffset,0 ; Null terminate
End Function

; Null terminated string peek.
Function PeekString$(mBankAddr,iBufferOffset = 0)
	Local sOutStr$ = "",iByte
	
	For n = 0 To BankSize(mBankAddr)
		iByte = PeekByte(mBankAddr,iBufferOffset)
		If iByte <> 0 
			sOutStr$ = sOutStr$ + Chr(iByte)
		Else
			Exit
		EndIf
		iBufferOffset = iBufferOffset + 1
	Next

	Return sOutStr$
End Function

; Saves a bank to disk.
Function OutBank(sFile$,mBank)
	Local fhl
	fhl = WriteFile(sFile$)
	WriteBytes mBank,fhl,0,BankSize(mBank)
	CloseFile fhl
End Function