;Somewhere in the space
;First game from my Retro series
;Programming by Denis Grachyov(aka Gamemaster)
;v1.01 - 16 November 2003
;==============================
AppTitle "Somewhere In The Space"
HidePointer 
If CommandLine$()="-win" Then Graphics3D 400,300,16,3 Else Graphics3D 400,300,16,1
SetBuffer BackBuffer()
WireFrame True;enable wireframe
Include "RetroMusic.bb";include RetroMusic DLL functions 
;===============
Global hsc=0;best score
SetFont LoadFont ("Spectrum normal.fon",10,1) 
;===============
Const FPSKA=30;fps
;===============
Global score=0
;star type
Type star
Field entity
Field kind;0-background star;1-asteroid part
;asteroid type
End Type
Type asteroid
Field entity
End Type
;===============
camera=CreateCamera()
MoveEntity camera,0,0,-200
light=CreateLight()
TurnEntity light,45,45,0
init_ym()
crash=LoadSound ("sfx\crash.wav") 
zap=LoadSound("sfx\zap.wav")
bum=LoadSound("sfx\bum.wav")
engine=LoadSound("sfx\engine.wav") 
SoundVolume engine,0.5 
.regame
hsc=0
play_ym("sfx\menu.ym") ;
;===========
;===============
score=0
screen=0;0-menu 1-game 2-gameover
distance=0
shield=10
level#=1.3
clicked=False
bah_time=0
paused=False
RotateEntity camera,0,0,0
FlushMouse
Gosub loadhsc;load best score
MoveMouse 200,150
;===============
SeedRnd 200
period=1000/FPSKA
time=MilliSecs()-period
;===============
While Not KeyHit(1)
Repeat
	elapsed=MilliSecs()-time
	Until elapsed

	;how many 'frames' have elapsed	
	ticks=elapsed/period
	
	;fractional remainder
	tween#=Float(elapsed Mod period)/Float(period)

	For k=1 To ticks
		If k=ticks Then CaptureWorld
		time=time+period
Select screen
Case 0
Gosub stars
Case 1
If KeyHit(25)=True Then paused=Not paused:FlushKeys:oldmx#=MouseX():oldmy#=MouseY()
If paused=False Then
Gosub stars
Gosub game
EndIf
Case 2
RotateEntity camera,Rnd(-5,5),Rnd(-5,5),0
End Select
UpdateWorld
Next
RenderWorld tween#
Select screen
Case 0
Color 255,255,255
Text GraphicsWidth()/2,4,"Somewhere In The Space",1
Text GraphicsWidth()/2,160,"Best Score: "+hsc,1
Color 255,255,0
Text GraphicsWidth()/2,20,"First game from retro series",1
Text GraphicsWidth()/2,30,"by Gamemaster",1
Color 25,40,255
Text GraphicsWidth()/2,260,"Made in Russia",1
Color 25,240,25
Text GraphicsWidth()/2,270,"Made in BlitzBasic",1
Text GraphicsWidth()/2,280,"www.blitzbasic.com",1
Color Rnd(120,255),Rnd(120,255),Rnd(120,255)
Text GraphicsWidth()/2,70,"Hit mouse to play",1
If MouseHit(1)=True Then screen=1:play_ym("sfx\"+Str(Int(Rnd(1,6)))+".ym") ;
Case 1
Color 255,0,0
If paused Then 
MoveMouse oldmx#,oldmy#:Text 200,4,"Paused",1 
Line oldmx,oldmy-3,oldmx,oldmy+3 
Line oldmx-3,oldmy,oldmx+3,oldmy 
Else
Line MouseX(),MouseY()-3,MouseX(),MouseY()+3 
Line MouseX()-3,MouseY(),MouseX()+3,MouseY() 
EndIf
Color 255,55,20
If clicked=True Then Line 20,GraphicsHeight(),MouseX(),MouseY():Line 380,GraphicsHeight(),MouseX(),MouseY()
Color Rnd(120,255),Rnd(120,255),Rnd(120,255)
Text 4,4,"Score: "+score
Text 4,280,"Shield: "
For k=0 To shield
Color Rnd(120,255),Rnd(120,255),Rnd(120,255)
Rect 80+k*20,280,10,10 
Next
If shield<0 Then screen=2:play_ym("sfx/go.ym")
distance=distance+4
If (distance Mod 1000)=0 Then level#=level#+0.1:
Case 2
Text GraphicsWidth()/2,GraphicsHeight()/2,"GAME OVER",1,1
Color Rnd(120,255),Rnd(120,255),Rnd(120,255)
Text 4,4,"Score: "+score
Text 4,280,"Shield: "
End Select
Color 50,50,250
Rect 0,0,400,300,0 
Color 20,250,50
Rect 1,1,398,298,0 
Color 250,50,250
Rect 2,2,396,296,0 

Flip
Wend
;free all entitys
For g.star = Each star
FreeEntity g\entity:Delete g
Next
For z.asteroid = Each asteroid
FreeEntity z\entity:Delete z
Next
If score>hsc Then Gosub savehsc
If screen<>0 Then screen=0:Goto regame
stop_ym
free_ym
End
.stars
;--update starts---
star_num=0
For g.star = Each star
If g\kind=0 Then star_num=star_num+1 Else RotateMesh g\entity,5,-5,-5
Next
If star_num<200 Then 
g.star=New star
g\entity=CreateCube()
ScaleEntity g\entity,0.15,0.15,0.15
TurnEntity g\entity,Rnd(-50,50),Rnd(-50,50),0
EndIf
For g.star = Each star
MoveEntity g\entity,0,0,-2
If EntityZ(g\entity)<-210 Then FreeEntity g\entity:Delete g
Next
Return
.game
;--generation asteroids--
If Rnd(0,100)>(100-level#)  Then
z.asteroid=New asteroid
z\entity=CreateSphere(3)
ScaleEntity z\entity,6,6,6:EntityRadius z\entity,6
EntityColor z\entity,240,200,12 
TurnEntity z\entity,Rnd(-2,2),Rnd(-3,3),0
PositionEntity z\entity,0,0,600
EntityPickMode z\entity,1 
EndIf
;-----controls---
If MouseHit(1)>0 Then clicked=True Else clicked=False
If clicked=True Then chan=PlaySound (zap) 
;--------------------
For z.asteroid = Each asteroid
MoveEntity z\entity,0,0,-5
RotateMesh z\entity,10,10,10
If EntityZ(z\entity)<-210 Then FreeEntity z\entity:Delete z:bah_time=bah_time+20:shield=shield-1:chan3=PlaySound(crash):Goto Ends
If EntityZ(z\entity)>20 Then Goto Ends
e=CameraPick( camera,MouseX(),MouseY() )
If  e=z\entity And clicked=True Then makebum(z\entity):FreeEntity z\entity:Delete z:chan2=PlaySound (bum):Goto ends
If  e=z\entity Then EntityColor z\entity,255,0,0 Else  EntityColor z\entity,240,200,12 
.Ends
Next
;--fx's----
If bah_time>0 Then RotateEntity camera,Rnd(-5,5),Rnd(-5,5),0:bah_time=bah_time-1 Else RotateEntity camera,0,0,0
;----------
Return
;function creates a asteroid bang
Function makebum(enta)
score=score+10
For c=1 To 20
g.star=New star
g\kind=1
g\entity=CreateSphere(2)
PositionEntity g\entity,EntityX(enta),EntityY(enta),EntityZ(enta)
ScaleEntity g\entity,0.5,0.5,0.5
TurnEntity g\entity,Rnd(-50,50),Rnd(-50,50),0
EntityColor g\entity,240,200,12
Next
End Function
;loading best score
.loadhsc
in=ReadFile("score.dat") 
If in Then hsc=ReadInt (in):CloseFile in Else hsc=0
Return
;save best score
.savehsc
out=WriteFile("score.dat") 
WriteInt (out,score)
CloseFile out
Return